unit Unit1;
{
Jos 2 kanavaa on kytss, pit olla ainakin 2-akselinen joystick-ohjain
Jos kaikki 4 kanavaa, niin toinen 2-kanavainen ohjain lis.

Viritetn kirjoittamalla Kiuas.ini -tiedostoon sopivat arvot.
Use: 0 tai 1, Kytetnk ko. kanavaa vai ei.
BVakio: anturivalmistajan antama NTC:n ominaisvakio (3977),
        jos kytetn, niin Count2 ja Temp2 pit olla nollia
Kytke kaikkiin valittuihin (Use=1) kanaviin jotakin (anturi, oikosulku
tai vastus), muuten tulee ???-lukemia. Mys valitun kanavan parilla
pit olla jotain kiinni, vaikka se ei olisikaan valittu.
Kanavat on pareittain, siis kanava 1 ja 2, toinen pari kanavat 3 ja 4.

VIRITYS: Tarvitaan kaksi lukemaa jokaiselle kanavalle:
Count0: lukema, kun anturin tilalla on oikosulku
Count1: lukema, kun anturin tilalla on 10k vastus

Temp1: 25 (25C vastaa 10k vastusta)

Joa BVakio ei ole tiedossa, tarvitaan viel lukema, kun anturi on
tietyss lmptilassa (ei kovin lhell 25C:ta):
Temp2: lmptila, esim. 50 (C)
Count2: lukema

Count-lukemat heiluu, joten kannattaa hetken aikaa seurailla
ja valita sellainen keskimrinen lukema.

Jos joystick viritetn (Windows Ohjauspaneeli), menee em. viritykset uusiksi.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Ohje1: TMenuItem;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    Label11: TLabel;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    GroupBox2: TGroupBox;
    BEdit1: TEdit;
    Button5: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Kanava1: TPanel;
    Kanava2: TPanel;
    Kanava3: TPanel;
    Kanava4: TPanel;
    Temp1: TEdit;
    Button1: TButton;
    Temp2: TEdit;
    Button2: TButton;
    Temp3: TEdit;
    Button3: TButton;
    Temp4: TEdit;
    Button4: TButton;
    Button7: TButton;
    Button6: TButton;
    procedure OnTimer1(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure OnExit1(Sender: TObject);
    procedure Create1(Sender: TObject);
    procedure Ohje1Click(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Close1(Sender: TObject; var Action: TCloseAction);
    procedure TempClick(Sender: TObject);
  private
    { Private declarations }
    ViritysCh, ViritysSt: Integer;
    ViritysBtn: TButton;
    ViritysCnt0, ViritysCnt1, ViritysTem1: Integer;
    TempClicked: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses MMSystem, JoyInit;

{$R *.DFM}

type
  PInt = ^Integer;

(*  Abs25 = 273+25;         { abs. lmptila 25C:ssa }
  B25_85 = 3977;          { NTC:n ominaisvakio }
  XPosZro = 94004;         { oikosulkua vastaava lukema }
  XPos10k = 174408 - XPosZro; { 10 k vastaava lukema - Zro} *)

var
  JoyI, JoyJ: TJoyInfoEx;
  L: Integer;
  T: Real;
  Aste, TitStr: String;
  Lukemat: array[0..3] of array[0..31] of Integer;
  LukIx: Integer = 0;
  ChCount: array[0..3] of PInt;
  ChOk: array[0..3] of Boolean;
  Kanavat: array[0..3] of TPanel;
  Asteet: array[0..3] of TEdit;

function Summa(const Taulu: array of Integer; Kpl: Integer): Integer;
var
  Li: Integer;
begin
  Result := 0;
  for Li := 0 to Kpl - 1 do Result := Result + Taulu[Li];
end;

(*** AIKAVLEIN LUETAAN JOYSTICK-ARVOT ***)

procedure TForm1.OnTimer1(Sender: TObject);
var
  ApuI: Integer;
begin
  if Joy1On then ChOk[0] := joyGetPosEx(JOYSTICKID1, @JoyI) = 0;
  if Joy2On then ChOk[2] := joyGetPosEx(JOYSTICKID2, @JoyJ) = 0;
  ChOk[1] := ChOk[0];
  ChOk[3] := ChOk[2];
  for ApuI := 0 to 3 do
  begin  { Lukemat tallennetaan 32 lukeman puskuriin }
    if JoyVakiot[ApuI].Use and ChOk[ApuI]
    then Lukemat[ApuI][LukIx and 31] := ChCount[ApuI]^;
    ChCount[ApuI]^ := 0;
  end;
  Inc(LukIx);
  if LukIx and 15 = 0 then
  begin   { 16 lukeman vlein nytetn }
    TitStr := '';
    for ApuI := 0 to 3 do
    with JoyVakiot[ApuI] do
    if Use then
    begin
      if ChOk[ApuI] then
      begin
        L := Summa(Lukemat[ApuI], 32);   { 32 lukeman summa }
        if L <= Cnt0 then L := Cnt0 + 100;
        T := BVak / ((ln((L - Cnt0) / Cnt1)) + BVak / Tem1) - AbsT;
        Str(T:3:0, Aste);
        if WindowState <> wsMinimized then
        begin
          Kanavat[ApuI].Caption := ' ' + IntToStr(L);
          with Asteet[ApuI] do
          if ReadOnly or not TempClicked then Text := Aste;
        end;
      end
      else
      begin
        Aste := '???';
        if WindowState <> wsMinimized then
        begin
          Kanavat[ApuI].Caption := ' ?????';
          Asteet[ApuI].Text := '???';
        end;
      end;
      TitStr := TitStr + '  ' + Aste;
    end;
    Application.Title := TitStr + ' C';
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.OnExit1(Sender: TObject);
begin
  Close;
end;

(*** ALKUASETUKSET ***)

procedure TForm1.Create1(Sender: TObject);
var
  ApuI: Integer;
begin
  ViritysCh := -1;
  ChCount[0] := @JoyI.wXpos;
  ChCount[1] := @JoyI.wYpos;
  ChCount[2] := @JoyJ.wXpos;
  ChCount[3] := @JoyJ.wYpos;
  Kanavat[0] := Kanava1;
  Kanavat[1] := Kanava2;
  Kanavat[2] := Kanava3;
  Kanavat[3] := Kanava4;
  for ApuI := 0 to 3 do Kanavat[ApuI].Visible := JoyVakiot[ApuI].Use;
  Asteet[0] := Temp1;
  Asteet[1] := Temp2;
  Asteet[2] := Temp3;
  Asteet[3] := Temp4;
  CheckBox1.Checked := JoyVakiot[0].Use;
  CheckBox2.Checked := JoyVakiot[1].Use;
  CheckBox3.Checked := JoyVakiot[2].Use;
  CheckBox4.Checked := JoyVakiot[3].Use;
  ZeroMemory(@JoyI, SizeOf(JoyI));
  ZeroMemory(@JoyJ, SizeOf(JoyJ));
  JoyI.dwSize := SizeOf(JoyI);
  JoyI.dwFlags := JOY_CAL_READ3 or JOY_CAL_READALWAYS
               or JOY_RETURNX or JOY_RETURNY;
  JoyJ.dwSize := SizeOf(JoyJ);
  JoyJ.dwFlags := JOY_CAL_READ3 or JOY_CAL_READALWAYS
               or JOY_RETURNX or JOY_RETURNY;
  TempClicked := False;
end;


(*** LOPETUS ***)

procedure TForm1.Close1(Sender: TObject; var Action: TCloseAction);
begin
  if IniFileChanged then UpDateIniFile;
end;

(*** HELP ***)

procedure TForm1.Ohje1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

(*** VALITAAN KANAVAT  ***)

procedure TForm1.CheckBoxClick(Sender: TObject);
begin
  with TCheckBox(Sender) do
  begin
    JoyVakiot[Tag and 3].Use := Checked;
    Kanavat[Tag and 3].Visible := Checked;
  end;
  Joy1On := JoyVakiot[0].Use or JoyVakiot[1].Use;
  Joy2On := JoyVakiot[2].Use or JoyVakiot[3].Use;
  IniFileChanged := True;
end;

(*** KANAVIEN VIRITYS ***)

const
  VirtTxt: array[0..3] of String = (
  ('Oikosulje anturi ja paina Jatka.'#13#10#10#10'Ohita-napilla otetaan kyttn vanha viritysarvo'),
  ('Anturi lmptilaan 1 (Esim. 25C). Kirjoita lmptila ja paina Jatka'),
  ('Anturi lmptilaan 2 (esim. 50C). Kirjoita lmptila ja paina Jatka'#13#10#10'Tai anna B-vakio ja paina OK'),
  (''));

procedure TForm1.Button1Click(Sender: TObject);
var
  ApuI: Integer;
begin
  if ViritysCh in [0..3] then
  begin
    Inc(ViritysSt);
    if TButton(Sender).Tag = 6 then ViritysSt := 5; { Peruuta }
    case ViritysSt of
    1: begin  { oikosulkulukema annettu }
         if TButton(Sender).Tag = 5
         then ViritysCnt0 := JoyVakiot[ViritysCh].Cnt0
         else ViritysCnt0 := Summa(Lukemat[ViritysCh], 32);
         Asteet[ViritysCh].ReadOnly := False;
         Asteet[ViritysCh].Color := clWhite;
         Asteet[ViritysCh].Show;
       end;
    2: begin
         if TButton(Sender).Tag = 5 then
         begin
           ViritysCnt1 := JoyVakiot[ViritysCh].Cnt1;
           ViritysTem1 := JoyVakiot[ViritysCh].Tem1;
         end
         else
         begin
           ViritysCnt1 := Summa(Lukemat[ViritysCh], 32) - ViritysCnt0;
           ViritysTem1 := StrToInt(Asteet[ViritysCh].Text) + AbsT;
         end;
         BEdit1.Text := IntToStr(JoyVakiot[ViritysCh].BVak);
         GroupBox2.Show;
       end;
    else
      begin  { viritys loppuu }
        if ViritysSt < 5 then
        with JoyVakiot[ViritysCh] do
        begin
          Cnt0 := ViritysCnt0;
          Cnt1 := ViritysCnt1;
          Tem1 := ViritysTem1;
          if TButton(Sender).Tag = 4 then
          begin { B-Vakio annettu }
            BVak := StrToInt(BEdit1.Text);
            Cnt2 := 0;
          end
          else
          begin { Lmptila 2 annettu }
            if TButton(Sender).Tag < 4 then
            begin
              Tem2 := StrToInt(Asteet[ViritysCh].Text) + AbsT;
              Cnt2 := Summa(Lukemat[ViritysCh], 32) - Cnt0;
            end;
            if Cnt2 > 0 then
            BVak := Round(Ln(Cnt1 / Cnt2) / (1 / Tem1 - 1 / Tem2))
          end;
          UpDateIniFile;
        end;
        ViritysBtn.Caption := 'Virit';
        GroupBox2.Hide;
        GroupBox1.Hide;
        for ApuI := 0 to 3 do Kanavat[ApuI].Visible := JoyVakiot[ApuI].Use;
        Asteet[ViritysCh].ReadOnly := True;
        Asteet[ViritysCh].Color := clBtnFace;
        Asteet[ViritysCh].Show;
        ViritysCh := -1;
        TempClicked := False;
      end;
    end;
    Memo1.Lines.Text := VirtTxt[ViritysSt and 3];
  end
  else if TButton(Sender).Tag < 4 then
  begin   { viritys alkaa }
    ViritysBtn := TButton(Sender);
    ViritysCh := ViritysBtn.Tag and 3;
    ViritysSt := 0;
    ViritysBtn.Caption := 'Jatka';
    Memo1.Lines.Text := VirtTxt[0];
    Label11.Top := Kanavat[ViritysCh].Top + 8;
    GroupBox1.Show;
    for ApuI := 0 to 3 do Kanavat[ApuI].Visible := ApuI = ViritysCh;
    Asteet[ViritysCh].Hide;
    TempClicked := False;
  end
end;

procedure TForm1.TempClick(Sender: TObject);
begin
  if (ViritysCh >= 0) and not TempClicked
  then with TEdit(Sender) do
  begin       { Lmptilalukeman editoinnin alku }
    TempClicked := True;
    SelStart := 0;
    SelLength := 5;
  end;
end;

end.
